/*
 * 			Combinations
 * 
 * 			Combinations.h
 * 
 * 							2005 by Harald Obermaier
 */
#ifndef _COMBINATIONS_H_
#define _COMBINATIONS_H_

#include "GuiElements.h"

#define WHITE 	1
#define RED		2



//Saves data of each turn
class Guess
{
private:
	int combination[4];	//Colors of this guess
	int rating[4];		//Colors of the rating of this guess
	
public:
	int Rate(int c[4]);
	void Reset();
	void setColor(int i,int color);
	int getColor(int i);
	int getRating(int i);
	
};

//Our game-class
class Combinations
{
private:
	int mousex;		//Mouse coordinates - x
	int mousey;		//Mouse coordinates - y
	int selcolor;	//Index of color being dragged -  -1 if none
	int win;		// 1 = victory, -1 = defeat, 0 = still playing
	unsigned int starttime;	//Time the game was started
	
	int combination[4];	//Goal-combination
	int turn;			//Number of current turn
	Guess guesses[10];	// 10 turns
	GuiElement buttons[8];	//8 Buttons/labels
	
	void MouseDown(SDL_MouseButtonEvent click);
	void MouseUp(SDL_MouseButtonEvent click);
	void MouseMove(SDL_MouseMotionEvent move);
	void Rate();
	void Randomize();

public:
	Combinations();
	~Combinations();
	void NewGame();
	void Render();
	int Input();

};


#endif //_COMBINATIONS_H_
